<?php
/**
 * @package google base feeder
 * @copyright Copyright 2007-2008 Numinix Technology http://www.numinix.com
 * @copyright Portions Copyright 2003-2006 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: google_base.php 19 2008-11-27 06:50:44Z numinix $
 * @author Numinix Technology
 */
 
  class google_base {
   
    function google_base_fwrite($output='', $mode, $type) {
      $output = implode("\n", $output);
      if(strtolower(CHARSET) != 'utf-8') {
        $output = utf8_encode($output);
      } else {
        $output = $output;
      }
      $outfile = DIR_FS_CATALOG . GOOGLE_FROOGLE_DIRECTORY . GOOGLE_FROOGLE_OUTPUT_FILENAME . "_" . $type . ".xml"; //example domain_products.xml
      $fp = fopen($outfile, $mode);
      $retval = fwrite($fp, $output, GOOGLE_FROOGLE_OUTPUT_BUFFER_MAXSIZE);
      return $retval;
    }
    
    function trim_array($x) {
      if (is_array($x)) {
         return array_map('trim_array', $x);
      } else {
       return trim($x);
      }
    } 

    function get_feed($feed_parameter) {
      switch($feed_parameter) {
        case 'fy':
          $feed = 'yes';
          break;
        case 'fn':
          $feed = 'no';
          break;
        default:
          $feed = 'no';
          break;
      }
      return $feed;
    }

    function get_upload($upload_parameter) {
      switch($upload_parameter) {
        case 'uy':
          $upload = 'yes';
          break;
        case 'un':
          $upload = 'no';
          break;
        default:
          $upload = 'no';
          break;
      }
      return $upload;
    }
    
    function get_type($type_parameter) {
      switch($type_parameter) {
        case 'tp':
          $type = 'products';
          break;
        case 'td':
          $type = 'documents';
          break;
        case 'tn':
          $type = 'news';
          break;
        default:
          $type = 'products';
          break;
      }
      return $type;
    }
    
    function numinix_categories_check($categories_list, $products_id, $charge) {
      if ($categories_list == '') {
        if ($charge == 1) {
          return true;
        } elseif ($charge == 2) {
          return false;
        }
      } else {
        $categories_array = split(',', $categories_list);
        $match = false;
        foreach($categories_array as $category_id) {
          if (zen_product_in_category($products_id, $category_id)) {
            $match = true;
            break;
          }
        }
        if ($match == true) {
          return true;
        } else {
          return false;
        }
      }
    }
    
    function google_base_get_category($products_id) {
      global $categories_array, $db;
      static $p2c;
      if(!$p2c) {
        $q = $db->Execute("SELECT *
                          FROM " . TABLE_PRODUCTS_TO_CATEGORIES);
        while (!$q->EOF) {
          if(!isset($p2c[$q->fields['products_id']]))
            $p2c[$q->fields['products_id']] = $q->fields['categories_id'];
          $q->MoveNext();
        }
      }
      if(isset($p2c[$products_id])) {
        $retval = $categories_array[$p2c[$products_id]]['name'];
        $cPath = $categories_array[$p2c[$products_id]]['cPath'];
      } else {
        $cPath = $retval =  "";
      }
      return array($retval, $cPath);
    }
    
    function google_base_category_tree($id_parent=0, $cPath='', $cName='', $cats=array()){
      global $db, $languages;
      $cat = $db->Execute("SELECT c.categories_id, c.parent_id, cd.categories_name
                           FROM " . TABLE_CATEGORIES . " c
                             LEFT JOIN " . TABLE_CATEGORIES_DESCRIPTION . " cd on c.categories_id = cd.categories_id
                           WHERE c.parent_id = '" . (int)$id_parent . "'
                           AND cd.language_id='" . (int)$languages->fields['languages_id'] . "'
                           AND c.categories_status= '1'",
                           '', false, 150);
      while (!$cat->EOF) {
        $cats[$cat->fields['categories_id']]['name'] = (zen_not_null($cName) ? $cName . ', ' : '') . trim($cat->fields['categories_name']); // previously used zen_froogle_sanita instead of trim
        $cats[$cat->fields['categories_id']]['cPath'] = (zen_not_null($cPath) ? $cPath . ',' : '') . $cat->fields['categories_id'];
        if (zen_has_category_subcategories($cat->fields['categories_id'])) {
          $cats = $this->google_base_category_tree($cat->fields['categories_id'], $cats[$cat->fields['categories_id']]['cPath'], $cats[$cat->fields['categories_id']]['name'], $cats);
        }
        $cat->MoveNext();
      }
      return $cats;
    }
    
    function google_base_sanita($str, $rt=false) { // currently using zen_xml_sanitizer below instead of zen_froogle_sanita
      $str = strip_tags($str);
      $str = str_replace(array("\t" , "\n", "\r"), ' ', $str);
      $str = preg_replace('/\s\s+/', ' ', $str);
  //  $str = str_replace(array("&reg;", "", "&copy;", "", "&trade;", ""), ' ', $str);
      $str = htmlentities(html_entity_decode($str));
      $in = $out = array();
      $in[] = "&reg;"; $out[] = '(r)';
      $in[] = "&copy;"; $out[] = '(c)';
      $in[] = "&trade;"; $out[] = '(tm)';
  //    $str = str_replace($in, $out, $str);
      if($rt) {
        $str = str_replace(" ", "&nbsp;", $str);
        $str = str_replace("&nbsp;", "", $str);
      }
      $str = str_replace(array("&lt;", "&gt;"), array("<", ">"), $str);    
      $str = trim($str);
      return $str;
    }

    
    function google_base_xml_sanitizer($str, $cdata = false) {
      $str = str_replace(array("\t" , "\n", "\r"), ' ', $str);
      $str = htmlentities(html_entity_decode($str));
      $str = str_replace(array("&reg;", "&copy;", "&trade;"), array('(r)', '(c)', '(tm)'), $str);
      $out = "";
      $length = strlen($str);
      for ($i = 0; $i < $length; $i++) {
        $current = ord($str{$i});
        if (($current == 0x9) || ($current == 0xA) || ($current == 0xD) || (($current >= 0x20) && ($current <= 0xD7FF)) || (($current >= 0xE000) && ($current <= 0xFFFD)) || (($current >= 0x10000) && ($current <= 0x10FFFF))) {
          $out .= chr($current);
        } else {
          $out .= " ";
        }
      }
      $str = trim($out);
      $str = str_replace(array("&lt;", "&gt;"), array("<", ">"), $str);
      if ($cdata) {
        $str = '<![CDATA[' . $str . ']]>';
      } 
      return $str;
    }
    
    function html_translate($value) {        
      $value = preg_replace("//", "&#192;", $value);        
      $value = preg_replace("//", "&#193;", $value);        
      $value = preg_replace("//", "&#196;", $value);        
      $value = preg_replace("//", "&#199;", $value);        
      $value = preg_replace("//", "&#200;", $value);        
      $value = preg_replace("//", "&#201;", $value);        
      $value = preg_replace("//", "&#203;", $value);        
      $value = preg_replace("//", "&#204;", $value);        
      $value = preg_replace("//", "&#205;", $value);        
      $value = preg_replace("//", "&#207;", $value);        
      $value = preg_replace("//", "&#210;", $value);        
      $value = preg_replace("//", "&#211;", $value);        
      $value = preg_replace("//", "&#214;", $value);        
      $value = preg_replace("//", "&#217;", $value);        
      $value = preg_replace("//", "&#218;", $value);        
      $value = preg_replace("//", "&#220;", $value);
      $value = preg_replace("//", "&#220;", $value);
      $value = preg_replace("//", "&#223;", $value);        
      $value = preg_replace("//", "&#224;", $value);        
      $value = preg_replace("//", "&#225;", $value);        
      $value = preg_replace("//", "&#228;", $value);        
      $value = preg_replace("//", "&#231;", $value);        
      $value = preg_replace("//", "&#232;", $value);        
      $value = preg_replace("//", "&#233;", $value);        
      $value = preg_replace("//", "&#235;", $value);        
      $value = preg_replace("//", "&#236;", $value);        
      $value = preg_replace("//", "&#237;", $value);        
      $value = preg_replace("//", "&#239;", $value);        
      $value = preg_replace("//", "&#242;", $value);        
      $value = preg_replace("//", "&#243;", $value);        
      $value = preg_replace("//", "&#246;", $value);        
      $value = preg_replace("//", "&#249;", $value);        
      $value = preg_replace("//", "&#250;", $value);        
      $value = preg_replace("//", "&#252;", $value);        
      return $value;    
    }
    
    function google_base_image_url($products_image) {
      if($products_image == "") return "";

      $products_image_extention = substr($products_image, strrpos($products_image, '.'));
      $products_image_base = ereg_replace($products_image_extention, '', $products_image);
      $products_image_medium = $products_image_base . IMAGE_SUFFIX_MEDIUM . $products_image_extention;
      $products_image_large = $products_image_base . IMAGE_SUFFIX_LARGE . $products_image_extention;

      // check for a medium image else use small
      if (!file_exists(DIR_WS_IMAGES . 'medium/' . $products_image_medium)) {
        $products_image_medium = DIR_WS_IMAGES . $products_image;
      } else {
        $products_image_medium = DIR_WS_IMAGES . 'medium/' . $products_image_medium;
      }
      // check for a large image else use medium else use small
      if (!file_exists(DIR_WS_IMAGES . 'large/' . $products_image_large)) {
        if (!file_exists(DIR_WS_IMAGES . 'medium/' . $products_image_medium)) {
          $products_image_large = DIR_WS_IMAGES . $products_image;
        } else {
          $products_image_large = DIR_WS_IMAGES . 'medium/' . $products_image_medium;
        }
      } else {
        $products_image_large = DIR_WS_IMAGES . 'large/' . $products_image_large;
      }
      if ((function_exists('handle_image')) && (GOOGLE_FROOGLE_IMAGE_HANDLER == 'true')) {
        $image_ih = handle_image($products_image_large, '', '', '', '');
        $retval = (HTTP_SERVER . DIR_WS_CATALOG . $image_ih[0]);
      } else {
        $retval = (HTTP_SERVER . DIR_WS_CATALOG . $products_image_large);
      }
      return $retval;
    }
    
    function google_base_news_link($article_id) {
      $link = zen_href_link(FILENAME_NEWS_ARTICLE, 'article_id=' . (int)$article_id . $product_url_add, 'NONSSL', false);
      return $link;
    }
    
    function google_base_expiration_date($base_date) {
      if(GOOGLE_FROOGLE_EXPIRATION_BASE == 'now')
        $expiration_date = time();
      else
        $expiration_date = strtotime($base_date);
      $expiration_date += GOOGLE_FROOGLE_EXPIRATION_DAYS*24*60*60;
      $retval = (date('Y-m-d', $expiration_date));
      return $retval;
    }
    
    function ftp_file_upload($url, $login, $password, $local_file, $ftp_dir='', $ftp_file=false, $ssl=false, $ftp_mode=FTP_ASCII) {
      if(!is_callable('ftp_connect')) {
        echo FTP_FAILED . NL;
        return false;
      }
      if(!$ftp_file)
        $ftp_file = basename($local_file);
      ob_start();
      if($ssl)
        $cd = ftp_ssl_connect($url);
      else
        $cd = ftp_connect($url);
      if (!$cd) {
        $out = $this->ftp_get_error_from_ob();
        echo FTP_CONNECTION_FAILED . ' ' . $url . NL;
        echo $out . NL;
        return false;
      }
      echo FTP_CONNECTION_OK . ' ' . $url . NL;
      $login_result = ftp_login($cd, $login, $password);
      if (!$login_result) {
        $out = $this->ftp_get_error_from_ob();
  //      echo FTP_LOGIN_FAILED . FTP_USERNAME . ' ' . $login . FTP_PASSWORD . ' ' . $password . NL;
        echo FTP_LOGIN_FAILED . NL;
        echo $out . NL;
        ftp_close($cd);
        return false;
      }
  //    echo FTP_LOGIN_OK . FTP_USERNAME . ' ' . $login . FTP_PASSWORD . ' ' . $password . NL;
      echo FTP_LOGIN_OK . NL;
      if ($ftp_dir != "") {
        if (!ftp_chdir($cd, $ftp_dir)) {
          $out = $this->ftp_get_error_from_ob();
          echo FTP_CANT_CHANGE_DIRECTORY . '&nbsp;' . $url . NL;
          echo $out . NL;
          ftp_close($cd);
          return false;
        }
      }
      echo FTP_CURRENT_DIRECTORY . '&nbsp;' . ftp_pwd($cd) . NL;
      if (GOOGLE_BASE_PASV == 'true') {
        $pasv = true;
      } else {
        $pasv = false;
      }
      ftp_pasv($cd, $pasv);
      $upload = ftp_put($cd, $ftp_file, $local_file, $ftp_mode);
      $out = $this->ftp_get_error_from_ob();
      $raw = ftp_rawlist($cd, $ftp_file, true);
      for($i=0,$n=sizeof($raw);$i<$n;$i++){
        $out .= $raw[$i] . '<br/>';
      }
      if (!$upload) {
        echo FTP_UPLOAD_FAILED . NL;
        if(isset($raw[0])) echo $raw[0] . NL;
        echo $out . NL;
        ftp_close($cd);
        return false;
      } else {
        echo FTP_UPLOAD_SUCCESS . NL;
        echo $raw[0] . NL;
        echo $out . NL;
      }
      ftp_close($cd);
      return true;
    }

    function ftp_get_error_from_ob() {
      $out = ob_get_contents();
      ob_end_clean();
      $out = str_replace(array('\\', '<!--error-->', '<br>', '<br />', "\n", 'in <b>'),array('/', '', '', '', '', ''),$out);
      if(strpos($out, DIR_FS_CATALOG) !== false){
        $out = substr($out, 0, strpos($out, DIR_FS_CATALOG));
      }
      return $out;
    }

    function microtime_float() {
       list($usec, $sec) = explode(" ", microtime());
       return ((float)$usec + (float)$sec);
    }
  }
?>
